/***************************************************************************
                          exserview.cpp  -  description
                             -------------------
    begin                : Tue Jun 26 09:42:14 PDT 2001
    copyright            : (C) 2001 by root
    email                : root@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for Qt
#include <qprinter.h>
#include <qpainter.h>
#include <qmessagebox.h>
#include <qstring.h>

#include <unistd.h>

// application specific includes
#include "exserview.h"
#include "exserdoc.h"


ExserView::ExserView(ExserDoc* pDoc, QWidget *parent, const char* name, int wflags)
 : QMultiLineEdit(parent, name )
{
    doc=pDoc;
}

ExserView::~ExserView()
{
}

ExserDoc *ExserView::getDocument() const
{
	return doc;
}

void ExserView::update(ExserView* pSender){
	if(pSender != this){
	
		/* Get the received buffer pointer*/
		char *rdBuf = doc->getRdBuf();
		
		/* Set the multiline text to received buffer */
		setText( rdBuf );	
		
		/* Set the cursor to the end of the text */
		setCursorPosition(numLines(), 0, 0);
		end();
		
		/* Repaint the window */
		repaint();
	}
}

void ExserView::print(QPrinter *pPrinter)
{
  if (pPrinter->setup(this))
  {
		QPainter p;
		p.begin(pPrinter);
		
		///////////////////////////////
		// TODO: add your printing code here
		///////////////////////////////
		
		p.end();
  }
}

void ExserView::closeEvent(QCloseEvent*)
{
  // LEAVE THIS EMPTY: THE EVENT FILTER IN THE ExserApp CLASS TAKES CARE FOR CLOSING
  // QWidget closeEvent must be prevented.
}

void ExserView::keyPressEvent( QKeyEvent *k )
{
		int serfd = doc->getSerfd();
		QString str(k->text());
		
//		QMultiLineEdit::keyPressEvent( k );
		/* send the key ( character to the serial port */		 	
		write( serfd, str, str.length());
}
